<template>
  <div>
    <div class="flex items-center q-mb-sm">
      <q-btn
        v-if="config.isEditable && config.editors.length"
        color="primary"
        label="Create new record"
        @click="addRecord"
      />
      <q-btn
        class="q-ml-auto"
        label="Export..."
        @click="exportData"
      >
      </q-btn>
    </div>
    <div
      class="q-mb-sm"
      v-if="fieldsGroup.length"
    >
      <group
        :group="fieldsGroup"
        :record="preFilters"
        :as-card="false"
      />
      <div class="q-mt-sm q-px-md">
        <q-btn
          label="Apply filter"
          color="green"
          @click="loadData"
        />
      </div>
    </div>
    <q-table
      :columns="columns"
      :data="filteredRows"
      :row-per-page-options="[1, 5, 10, 15, 20, 25, 50, 100]"
      :loading="isLoadingRecords"
      :pagination.sync="pagination"
      grid
    >
      <tr
        slot="header"
        slot-scope="props"
      >
        <q-th
          v-if="withActions"
        />
        <q-th
          v-for="(column, index) in config.columns"
          :key="`field_${index}`"
        >
          <q-select
            v-if="column.type === 'boolean'"
            v-model="filters['field_' + index]"
            :after="[{icon: 'search'}]"
            :float-label="columns[index].label"
            multiple
            :options="[{label: 'Yes', value: true}, {label: 'No', value: false}]"
          />
          <q-input
            v-else
            v-model="filters['field_' + index]"
            :after="[{icon: 'search'}]"
            :float-label="columns[index].label"
          />
        </q-th>
      </tr>
      <q-tr
        slot="body"
        slot-scope="props"
        :props="props"
      >
        <q-td
          v-if="withActions"
          :style="{position: 'sticky', left: '0', zIndex: 1}"
        >
          <q-btn
            v-if="withEditButton && config.editors.length"
            size="xs"
            color="blue"
            icon="build"
            round
            @click="editRecord(props.row.__index)"
          />
          <q-btn
            v-if="withRemoveButton"
            size="xs"
            color="red"
            icon="delete"
            round
            class="q-ml-xs"
            @click="removeRecord(props.row.__index)"
          />
        </q-td>
        <q-td
          v-for="(column, index) in columns"
          :key="`field_${index}`"
        >
          <div v-if="['json', 'pre'].indexOf(config.columns[index].type) > -1">
            <pre class="q-ma-none">{{ props.row[`field_${index}`] }}</pre>
          </div>
          <div v-else-if="config.columns[index].type === 'url'">
            <a
              :href="props.row[`field_${index}`]"
              :target="config.columns[index].config.openInNewTab ? '_blank' : undefined"
            >
              {{ props.row[`field_${index}`] }}
            </a>
          </div>
          <div v-else>
            {{ props.row[`field_${index}`] }}
          </div>
        </q-td>
      </q-tr>
    </q-table>
  </div>
</template>

<script>
  import QPageSticky from 'quasar-framework/src/components/layout/QPageSticky';
  import endpointsMixin from '../../../../../mixins/endpointsMixin';
  import apiMixin from '../../../../../mixins/apiMixin';
  import Group from '../../../../redactor/group';

  export default {
    name: 'reportTable',
    components: { Group, QPageSticky },
    mixins: [endpointsMixin, apiMixin],
    props: {
      config: {
        type: Object,
      },
      id: {
        type: [Number, String],
      },
      withEditButton: {
        type: Boolean,
        default: true,
      },
      withRemoveButton: {
        type: Boolean,
        default: true,
      },
      withRecordClick: {
        type: Boolean,
        default: true,
      },
    },
    created() {
      this.stubFilters();
      if (Object.values(this.preFilters).filter(() => Boolean).length === Object.keys(this.preFilters).length) {
        this.loadData();
      }
    },
    data() {
      return {
        records: [],
        sourceRecords: [],

        preFilters: {},
        filters: {},

        pagination: {
          sortBy: `field_${ this.config.defaultSortColumn }`,
          descending: this.config.defaultSortDirection === 'desc',
          page: 1,
          rowsPerPage: 10,
        },

        isLoadingRecords: false,
      };
    },
    watch: {
      // eslint-disable-next-line func-names
      '$store.state.location.location.id': function () {
        this.$nextTick(() => {
          this.stubFilters();
          this.loadData();
        });
      },
      id() {
        this.$nextTick(() => {
          this.loadData();
        });
      },
      'config.columns': {
        deep: true,
        handler() {
          this.$nextTick(() => {
            this.stubFilters();
          });
        },
      },
    },
    computed: {
      fieldsGroup() {
        return {
          fields: this.config.filters.filter(
            ({ type, config: { field } }) => !(type === 'collection' && field === 'location_id'),
          ),
        };
      },
      filteredRows() {
        const filtersLength = Object.values(this.filters).length;

        const filterKeys = Object.keys(this.filters);

        return [...this.records].filter(
          (row) => filtersLength === filterKeys.filter((key, index) => {
            const { type } = this.config.columns[index];

            if (type === 'boolean') {
              if (!this.filters[key].length) {
                return true;
              }
              return this.filters[key].indexOf(!!this.sourceRecords[row.__index][this.config.columns[index].field]) > -1;
            }

            if (!this.filters[key]) {
              return true;
            }

            return String(row[key]).toLowerCase().indexOf(String(this.filters[key]).toLowerCase()) > -1;
          }).length,
        );
      },
      columns() {
        return this.config.columns.map((column, index) => ({
          name: `field_${ index }`,
          label: column.label,
          align: 'left',
          field: `field_${ index }`,
          sortable: true,
        }));
      },
      withActions() {
        return this.config.isEditable && (this.withEditButton || this.withRemoveButton);
      },
    },
    methods: {
      exportData() {
        this.$q.dialog({
          title: 'Export data',
          message: 'Choose export variant',
          ok: true,
          cancel: true,
          options: {
            type: 'radio',
            model: 'full',
            items: [
              { label: 'Whole data', value: 'full' },
              { label: 'Only current page', value: 'visible' },
            ],
          },
        })
          .then((res) => {
            if (!this.sourceRecords[0]) {
              this.notifyError({
                title: 'Unable to export data',
                message: 'No existing records',
              });
              return;
            }

            const visibleIndexes = this.filteredRows.map(({ __index }) => __index);

            this.exportRowsInCSV(
              Object.keys(this.sourceRecords[0]),
              res === 'full'
                ? this.sourceRecords
                : this.sourceRecords.filter((item, index) => visibleIndexes.indexOf(index) > -1),
            );
          });
      },
      addRecord() {
        this.$store.commit('config/redactRecord', {
          config: this.config,
          record: {},
          isNewRecord: true,
        });
      },
      removeRecord(index) {
        this.$q.dialog({
          title: 'Remove record',
          message: 'Are you sure want to remove this record?',
          ok: true,
          cancel: true,
        })
          .then(() => {
            this.deleteRecord({
              endpoint: this.config.endpoint,
              record: this.sourceRecords[index],
            })
              .then(() => {
              });
          });
      },
      editRecord(index) {
        this.$store.commit('config/redactRecord', {
          config: this.config,
          record: this.sourceRecords[index],
          isNewRecord: false,
        });
      },
      stubFilters() {
        const filters = {};
        (this.config.columns || []).forEach(({ type }, index) => {
          filters[`field_${ index }`] = {
            boolean: [],
          }[type] || null;
        });
        this.filters = filters;

        const preFilters = {};

        (this.config.filters || []).forEach(({ type, config: { field, ...config } }) => {
          preFilters[field] = (({
            checkbox: () => [],
            collection: () => {
              if (field === 'location_id' && type === 'collection') {
                return this.$store.state.location.location.id || (config.isMultiple ? [] : null);
              }

              return config.isMultiple ? [] : null;
            },
            dropdown: () => (config.isMultiple ? [] : null),
          }[type]) || (() => null))();
        });

        this.preFilters = preFilters;
      },
      loadData() {
        this.isLoadingRecords = true;

        const query = {};

        Object.entries(this.preFilters).forEach(([key, value]) => {
          if ((Array.isArray(value) && value.length) || value) {
            query[key] = value;
          }
        });

        return new Promise((resolve) => {
          this.fetchData({
            endpoint: this.config.endpoint,
            query,
          })
            .then(({
              records,
            }) => {
              this.sourceRecords = records;
              resolve();

              this.formatDataResponse({
                records,
                columns: this.config.columns,
              })
                .then((res) => {
                  this.records = res;

                  this.isLoadingRecords = false;
                })
                .catch(() => {
                  this.isLoadingRecords = false;
                });
            })
            .catch(() => {
              this.isLoadingRecords = false;
            });
        });
      },
    },
  };
</script>
